Main Page Namespace List Class Hierarchy Alphabetical List Data Structures File List Namespace Members Data Fields Globals

# ExManagerId.h

Go to the documentation of this file.

    00001 /************************************************************************/
    00002 /* Ex Nihlo Engine by Hermanns Christophe                                                               */
    00003 /************************************************************************/
    00004 /* This program is free software; you can redistribute it and/or                */
    00005 /* modify it under the terms of the GNU General Public License                  */
    00006 /* as published by the Free Software Foundation; either version 2               */
    00007 /* of the License, or (at your option) any later version.                               */
    00008 /*                                                                                                                                              */
    00009 /* This program is distributed in the hope that it will be useful,              */
    00010 /* but WITHOUT ANY WARRANTY; without even the implied warranty of               */
    00011 /* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                 */
    00012 /*                                                                                                                                              */
    00013 /* See the GNU General Public License for more details.                                 */
    00014 /*                                                                                                                                              */
    00015 /* You should have received a copy of the GNU General Public License    */
    00016 /* along with this program; if not, write to the Free Software                  */
    00017 /* Foundation, Inc., 59 Temple Place - Suite 330,                                               */
    00018 /* Boston, MA  02111-1307, USA.                                                                                 */
    00019 /*                                                                                                                                              */
    00020 /* If you use a important part of this code please send me a mail               */
    00021 /* I just want to see where my code go thks :)                                                  */
    00022 /************************************************************************/
    00023
    00024 /************************************************************************/
    00025 /* Contact                                                              */
    00026 /************************************************************************/
    00027 /* ExNihilo Website :www.ploksoftware.org                               */
    00028 /*                                                                      */
    00029 /* Hermanns Christophe ExNihilo creator and main programmer             */
    00030 /*                                                                      */
    00031 /* Mail             : Data@ploksoftware.org                                                             */
    00032 /* ICQ              : 8030901                                                                                   */
    00033 /* MSN Messenger    : Data_7@hotmail.com                                                                */
    00034 /*                                                                      */
    00035 /* Benjamin Michotte Linux port, webmaster                              */
    00036 /*                                                                      */
    00037 /* Mail             :binny@ploksoftware.org                             */
    00038 /*                                                                      */
    00039 /************************************************************************/
    00040
    00041 /************************************************************************/
    00042 /* File Description                                                                                             */
    00043 /************************************************************************/
    00044 /* File Name   :InputActionList.h                                                                               */
    00045 /*                                                                                                                                              */
    00046 /* Star Date   :03/15/2002                                                                                              */
    00047 /*                                                                                                                                              */
    00048 /* Last Update :
    00049  * $Id: ExManagerId.h,v 1.11 2002/11/24 11:58:53 data Exp $
    00050  *
    00051  */
    00052
    00053 #ifndef _EXMANAGERID_H__
    00054 #define _EXMANAGERID_H__
    00055 //--------------------------------
    00056 // File to include
    00057 //--------------------------------
    00058 #include "ExDefine.h"
    00059 #include "ExManager.h"
    00060 #include "ExCObject.h"
    00061 #include "ExNihiloNameSpace.h"
    00062 //--------------------------------
    00063 class ExManagerId  : public ExManager
    00064 {
    00065 private:
    00066 //--------------------------------
    00067 // Variable
    00068 //--------------------------------
    00069         int m_ExIdCounter;
    00070
    00071         std::map<  ExNihilo::ExId   , ExNihilo::ExObjectInfo , std::less <ExNihilo::ExId  >  >                  *m_MapObjectInfo;
    00072         std::map<  ExNihilo::ExId   , ExNihilo::ExObjectInfo , std::less <ExNihilo::ExId  >  >::iterator        m_ItMapObjectInfo;
    00073
    00074         std::string GetAviableName(std::string Name,std::string Type,int occu);
    00075 //--------------------------------
    00076 // Singleton creation
    00077 //--------------------------------
    00078         static bool m_flag;
    00079         static ExManagerId *m_instance;
    00080         ExManagerId(void);
    00081         ~ExManagerId(void);
    00082 //--------------------------------
    00083
    00084 public:
    00085 //--------------------------------
    00086 // Methode
    00087 //--------------------------------
    00088         static ExManagerId*  CreateSingleton(void);
    00089         void Reset(void);
    00090         void Init(void);
    00091         void List(void);
    00092
    00093         ExNihilo::ExId RecordObject(ExCObject &object);
    00094         ExNihilo::ExId RecordObject(ExCObject *object);
    00095         ExNihilo::ExId  GetObjectId(std::string Name,std::string Type);
    00096         std::string             GetObjectName(ExNihilo::ExId id);
    00097         std::string             GetObjectType(ExNihilo::ExId id);
    00098
    00099         ExCAction InputAction(ExCAction Action);
    00100 };
    00101
    00102 #endif // _EXMANAGERID_H__